/* Copyright (C) 1998-1999 Kimmo.palin@helsinki.fi
   License: see COPYING
*/
#ifndef _COMPILER_H
#define _COMPILER_H
#include<gtk/gtk.h>
#include<string.h>
#include<stdio.h>
#include"ttk91vm.h"
#include"cpu.h"

/*Symbolitauluun talletetaan kaikki kohdatut symbolit. Jos symbolia
kytetn ennen mrittely, sen arvoa ei ole mritelty ja kyselijn
paikka talletetaan kyseisen symbolin uudelleensijoitustauluun. */

/* Symbolien tyypit */
#define SYMUNKNOWN 0
#define SYMEQU 1
#define SYMDCONST 2
#define SYMDSEQ 3
#define SYMADDR 4
#define SYMSYSCONST 5

/*Parsaamista varten*/
extern unsigned int line_count;
extern cpudev *boot_cpu;

typedef struct _rlent {
  bit32 rlpos;
  struct _rlent *next;
} rlent;

typedef struct _syment {
  char *name;
  int type;
  bit32 value; /* Koodiin upotettava arvo*/
  int def_line;  /* Mrittelyrivi, =0 jos ei mritelty*/  

  /*Uudelleen sijoitustaulu*/
  rlent *rltable;

  /*Tmn voisi vaihtaa hajautustauluksi*/
  struct _syment *next;
} syment;

extern syment SymTable;

#define ADDRMIN -32768
#define ADDRMAX 32767
#define ADDRMASK 0xFFFF

#define MEMFETCHMASK 3
#define MEMFETCHPOS 19

#define REGISTERMASK 7
#define REG1POS 21
#define REG2POS 16

#define OPERMASK 0xFF
#define OPERPOS 24

extern GtkCList *GtkSymList;

/* Defined in ttkasm.l */
void reset_lexer(FILE *fh);

void gtk_add_symbols();
bit32 get_symbol(char *name,bit32 progloc);
syment *find_symbol(char *name);
syment *create_symbol(char *name, int type, bit32 value);
int add_symbol(char *name,int type,bit32 value,int line);
void addrl_symbol(syment *ent, bit32 progloc);
bit32 get_symbol(char *name,bit32 progloc);
int comp_file(cpudev *cpu,const char *nimi);
void print_symboltable();

#endif



